from datetime import datetime


class BaseClass:
    pass


class MfgScannerTableType(BaseClass):
    def __init__(self, sha256: str = None, scanner_name: str = None):
        self.sha256 = sha256
        self.scanner_name = scanner_name

    def tuple(self) -> tuple:
        return self.sha256, self.scanner_name


class MfgTableType(BaseClass):
    def __init__(
        self,
        sha256: str = None,
        sha1: str = None,
        md5: str = None,
        malicious: int = 0,
        platform: str = None,
        malware_family: str = None,
        malware_group: str = None,
        additional_info: str = None,
        platform_num_scanner_votes: int = 0,
        platform_classification_detail: int = 0,
        malware_family_num_scanner_votes: int = 0,
        malware_family_classification_detail: int = 0,
        malware_group_num_scanner_votes: int = 0,
        malware_group_classification_detail: int = 0,
        scan_date: datetime = datetime.utcnow(),
        mfg_version_id: int = 0,
        threat: int = 0,
        ingest: int = 1,
        mfg_locked: int = 0,
        threat_locked: int = 0,
        *args,
        **kwargs
    ):
        self.sha256 = sha256
        self.sha1 = sha1
        self.md5 = md5
        self.malicious = malicious
        self.platform = platform
        self.malware_family = malware_family
        self.malware_group = malware_group
        self.additional_info = additional_info
        self.platform_num_scanner_votes = platform_num_scanner_votes
        self.platform_classification_detail = platform_classification_detail
        self.malware_family_num_scanner_votes = malware_family_num_scanner_votes
        self.malware_family_classification_detail = malware_family_classification_detail
        self.malware_group_num_scanner_votes = malware_group_num_scanner_votes
        self.malware_group_classification_detail = malware_group_classification_detail
        self.scan_date = scan_date
        self.mfg_version_id = mfg_version_id
        self.threat = threat
        self.ingest = ingest
        self.mfg_locked = mfg_locked
        self.threat_locked = threat_locked

    def tuple(self) -> tuple:
        return (
            self.sha256,
            self.sha1,
            self.md5,
            self.malicious,
            self.platform,
            self.malware_family,
            self.malware_group,
            self.additional_info,
            self.platform_num_scanner_votes,
            self.platform_classification_detail,
            self.malware_family_num_scanner_votes,
            self.malware_family_classification_detail,
            self.malware_group_num_scanner_votes,
            self.malware_group_classification_detail,
            self.scan_date,
            self.mfg_version_id,
            self.threat,
            self.ingest,
            self.mfg_locked,
            self.threat_locked,
        )


class UpdateMalwareTagsTableType(BaseClass):
    def __init__(self, sha256: str = None, malware_tag: str = None):
        self.sha256 = sha256
        self.malware_tag = malware_tag

    def tuple(self) -> tuple:
        return self.sha256, self.malware_tag
